//////////////////////////////////////////////////////////////////////////////////////////
//																													 //
//												 Particle Contest												 //
//														Entry														 //
/////////////////////////////////////////Includes/////////////////////////////////////////
#include <acknex.h>
#include <default.c>
#define PRAGMA_PATH "Picture"
#define PRAGMA_PATH "Model"
#define PRAGMA_PATH "Sound"
///////////////////////////////////////////Font///////////////////////////////////////////
//in main definiertyy
//////////////////////////////////////////Bilder//////////////////////////////////////////
BMAP* water_bmp = "water_par2.tga";
BMAP* rain_bmp = "rain_par.tga";
BMAP* splash_tga = "splash.tga";
BMAP* blitz_bmp = "blitz.bmp";
//////////////////////////////////////////Sound///////////////////////////////////////////
SOUND* thunder_snd = "thunder.wav";
SOUND* rain_snd = "rain.ogg";
///////////////////////////////////////////Var////////////////////////////////////////////
var on_off[8] = {0,1,0,0,0,0,0};
/////////////////////////////////////////Panels///////////////////////////////////////////
PANEL* text_1_help =
{
	digits(0,0, "Press F1 for Help", arial_normal, 1, 0);
}
PANEL* help_1_pan = 
{
	digits(400,100, "0 = OFF  -  1 = ON", arial_normal, 1, 0);
	digits(400,200, "1: Toggle Watter Sprayer On/Off  -  %3.0f", arial_normal, 1, on_off[0]);
	digits(400,225, "2: Toggle Alpha-losing On/Off  -  %3.0f", arial_normal, 1, on_off[1]);
	digits(400,250, "3: Toggle Turning On/Off  -  %3.0f", arial_normal, 1, on_off[2]);
	digits(400,275, "4: Toggle Leaking On/Off  -  %3.0f", arial_normal, 1, on_off[3]);
	digits(400,300, "5: Toggle Second Water Sprayer On/Off  -  %3.0f", arial_normal, 1, on_off[4]);
	digits(400,325, "6: Toggle More Random On/Off  -  %3.0f", arial_normal, 1, on_off[7]);
	digits(400,350, "Shift: Toggle Thunder On/Off  -  %3.0f", arial_normal, 1, on_off[6]);
	digits(400,375, "Alt: Toggle Rain On/Off  -  %3.0f", arial_normal, 1, on_off[5]);
	digits(400,400, "Ctrl: Toggle Camera Position", arial_normal, 1, 0);
	digits(400,450, "Esc to End", arial_normal, 1, 0);
	flags = CENTER_X;
}
PANEL* blitz =
{
	bmap = blitz_bmp;
	flags = TRANSLUCENT;
}
/////////////////////////////////////////Entitys//////////////////////////////////////////
ENTITY* boden;
ENTITY* spraenger;
ENTITY* spraenger_2;
ENTITY* spraenger_ring;
////////////////////////////////////////Functions/////////////////////////////////////////
function water_away(PARTICLE *p)
{
	if(on_off[1] == 1) p.alpha -= 1.2 * time_step;
	p.skill_a -= 1 * time_step;
	if(p.skill_a <= 0) p.lifespan = 0;
}
function rain_away(PARTICLE *p)
{
	p.skill_a -= 1 * time_step;
	if(p.skill_a <= 0) p.lifespan = 0;
}
function spraenger_effect(PARTICLE *p)
{
	p.bmap = water_bmp;
	p.size = 3;
	p.z += random(8)-4;
	if(on_off[7] == 1)
	{
		p.vel_x += random(1)-0.5;
		p.vel_y += random(1)-0.5;
	}
	p.alpha = random(25)+25;
	p.green = 56;
	p.flags |= (BRIGHT | MOVE);
	p.gravity = 1;
	p.skill_a = random(25)+25;
	p.event = water_away;
}
function spraenger_2_effect(PARTICLE *p)
{
	p.bmap = water_bmp;
	p.size = 3;
	p.z += random(6)-3;
	p.alpha = random(25)+25;
	p.green = 56;
	p.flags |= (BRIGHT | MOVE);
	p.gravity = 1+random(1);
	p.skill_a = random(25)+25;
	p.event = water_away;
}
function schlauch_effect(PARTICLE *p)
{
	p.bmap = water_bmp;
	p.size = 2;
	p.alpha = random(25)+25;
	p.flags |= (BRIGHT | MOVE);
	p.green = 56;
	p.gravity = 1;
	p.blue = random(50)+200;
	p.skill_a = random(25)+25;
	p.vel_x = random(3)-1.5;
	p.vel_y = random(3)-1.5;
	p.vel_z = random(8)+6;
	p.event = water_away;
}
function rain_effect(PARTICLE *p)
{
	p.bmap = rain_bmp;
	p.size = 3;
	p.x = camera.x - random(2000)+1000;
	p.y = camera.y - random(2000)+1000;
	p.z = camera.z+200;
	p.vel_x = 5+random(1);
	p.vel_y = 5+random(1);
	p.alpha = random(50)+25;
	p.flags |= (BRIGHT | MOVE);
	p.gravity = 1;
	p.skill_a = random(50)+25;
	p.event = rain_away;
}
function schlauch()
{
	VECTOR temp;
	wait(-1);
	while(me == NULL) wait(1);
	while(1)
	{
		while(on_off[3] == 0) wait(1);
		effect(schlauch_effect, 1, vec_for_vertex(temp, me, 118), normal);
		wait(2);
	}
}
function spranger_act()
{
	var animate_per = 10, anm;
	var vel1 = 0, vel2 = 0, vel3;
	var angle[3];
	var direction = 0;
	VECTOR temp;
	my.pan = 90;
	wait(1);
	while(1)
	{
		while(on_off[0] == 0) wait(1);
		ent_animate(me, "Running", animate_per, ANM_CYCLE);
		if(on_off[2] == 1)
		{
			if(direction == 0) animate_per += 0.8 * time_step;
			else animate_per -= 1 * time_step;
		}
		anm = animate_per;
		angle[2] = 45 - 90*animate_per/100;
		vel3 = cos(angle[2])*20;
		if((direction == 0)&&(animate_per >= 98)) direction = 1;
		if((direction == 1)&&(animate_per <= 2)) direction = 0;
		anm -= 50;
		anm *= 2;
		vel1 = sin(anm)*10;
		vel2 = 6;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 206), vector(vel1, vel2, abs(vel3)));
		vel2 = 4.5;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 165), vector(vel1, vel2, abs(vel3)));
		vel2 = 3;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 247), vector(vel1, vel2, abs(vel3)));
		vel2 = 1.5;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 288), vector(vel1, vel2, abs(vel3)));
		vel2 = 0;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 329), vector(vel1, vel2, abs(vel3)));
		vel2 = -1.5;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 1), vector(vel1, vel2, abs(vel3)));
		vel2 = -3;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 42), vector(vel1, vel2, abs(vel3)));
		vel2 = -4.5;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 124), vector(vel1, vel2, abs(vel3)));
		vel2 = -6;
		effect(spraenger_effect, 1, vec_for_vertex(temp, me, 83), vector(vel1, vel2, abs(vel3)));
		wait(1);
	}
}
function spranger_2_act()
{
	var vel1 = 0, vel2 = 0, vel3;
	var i = 0;
	var angle;
	VECTOR temp;
	wait(1);
	set(me, INVISIBLE);
	my.pan = 9;
	while(1)
	{
		while(on_off[4] == 0) wait(1);
		vel3 = 25;
		while(i < ent_vertices(me))
		{
			vel1 = cos(angle)*5*(random(0.5)+1);
			vel2 = sin(angle)*5*(random(0.5)+1);
			effect(spraenger_2_effect, 1, vec_for_vertex(temp, me, i+1), vector(vel1, vel2, vel3));
			angle += 18+random(9)-4.5;
			i++;
		}
		angle = 0;
		i = 0;
		wait(1);
	}
}
function rain_sound()
{
	var snd;
	var i;
	ENTITY* dummy;
	dummy = ent_create(NULL, nullvector, NULL);
	while(1)
	{
		i = 100;
		while(on_off[5] == 0) 
		{
			snd_tune(snd, i, 0, 0);
			i -= 5 * time_step;
			wait(1);
		}
		vec_set(dummy.x, camera.x);
		snd = ent_playloop(dummy, rain_snd, 100);
		while((snd < 100)&&(on_off[5] == 1)) wait(1);
		wait(1);
	}
}
function rain()
{
	VECTOR temp;
	rain_sound();
	while(1)
	{
		while(on_off[5] == 0) wait(1);
		effect(rain_effect, 80, camera.x, normal);
		wait(1);
	}
}
function gewitter()
{
	var alph;
	ENTITY* dummy;
	dummy = ent_create(NULL, nullvector, NULL);
	while(1)
	{
		vec_set(dummy.x, camera.x);
		while(on_off[6] == 0) wait(1);
		vec_set(dummy.x, camera.x);
		set(blitz, SHOW);
		blitz.alpha = 100;
		alph = random(25)+50;
		ent_playsound(dummy, thunder_snd, 100);
		while(blitz.alpha > alph)
		{
			blitz.alpha -= 10 * time_step;
			wait(1);
		}
		reset(blitz, SHOW);
		wait(random(20)+5);
		blitz.alpha = 100;
		alph = random(25)+50;
		while(blitz.alpha > alph)
		{
			blitz.alpha -= 20 * time_step;
			wait(1);
		}
		reset(blitz, SHOW);
		wait(random(200)+50);
	}
}
function switch_on_off()
{
	while(1)
	{
		if((key_1)&&(on_off[0] == 1)) 
		{
			on_off[0] = 0;
			while(key_1) wait(1);
		}
		if((key_1)&&(on_off[0] == 0)) 
		{
			on_off[0] = 1;
			while(key_1) wait(1);
		}
		if((key_2)&&(on_off[1] == 1)) 
		{
			on_off[1] = 0;
			while(key_2) wait(1);
		}
		if((key_2)&&(on_off[1] == 0)) 
		{
			on_off[1] = 1;
			while(key_2) wait(1);
		}
		if((key_3)&&(on_off[2] == 1)) 
		{
			on_off[2] = 0;
			while(key_3) wait(1);
		}
		if((key_3)&&(on_off[2] == 0)) 
		{
			on_off[2] = 1;
			while(key_3) wait(1);
		}
		if((key_4)&&(on_off[3] == 1)) 
		{
			on_off[3] = 0;
			while(key_4) wait(1);
		}
		if((key_4)&&(on_off[3] == 0)) 
		{
			on_off[3] = 1;
			while(key_4) wait(1);
		}
		if((key_5)&&(on_off[4] == 1)) 
		{
			on_off[4] = 0;
			while(key_5) wait(1);
		}
		if((key_5)&&(on_off[4] == 0)) 
		{
			on_off[4] = 1;
			while(key_5) wait(1);
		}
		if((key_6)&&(on_off[5] == 1)) 
		{
			on_off[7] = 0;
			while(key_6) wait(1);
		}
		if((key_6)&&(on_off[5] == 0)) 
		{
			on_off[7] = 1;
			while(key_6) wait(1);
		}
		if((key_alt)&&(on_off[5] == 1)) 
		{
			on_off[5] = 0;
			while(key_alt) wait(1);
		}
		if((key_alt)&&(on_off[5] == 0)) 
		{
			on_off[5] = 1;
			while(key_alt) wait(1);
		}
		if((key_shift)&&(on_off[6] == 1)) 
		{
			on_off[6] = 0;
			while(key_shift) wait(1);
		}
		if((key_shift)&&(on_off[6] == 0)) 
		{
			on_off[6] = 1;
			while(key_shift) wait(1);
		}
		if(key_f1)
		{
			toggle(help_1_pan, SHOW);
			while(key_f1) wait(1);
		}
		if((key_ctrl)&&(camera.x == 1000)) 
		{
			while(camera.x > 162)
			{
				camera.x -= 10 * time_step;
				wait(1);
			}
			camera.x = 161;
			while(key_ctrl) wait(1);
		}
		if((key_ctrl)&&(camera.x == 161)) 
		{
			while(camera.x < 999)
			{
				camera.x += 10 * time_step;
				wait(1);
			}
			camera.x = 1000;
			while(key_ctrl) wait(1);
		}
		wait(1);
	}
}