//////////////////////////////////////////////////////////////////////////////////////////
//																													 //
//												 Particle Contest												 //
//														Entry														 //
/////////////////////////////////////////Includes/////////////////////////////////////////
#include <acknex.h>
#include <default.c>
#define PRAGMA_PATH "Picture"
#define PRAGMA_PATH "Model"
#define PRAGMA_PATH "Sound"
///////////////////////////////////////////Var////////////////////////////////////////////
var status = 0;
var max_high = 5;
///////////////////////////////////////////Font///////////////////////////////////////////
//in main definiert
//////////////////////////////////////////Sounds//////////////////////////////////////////
SOUND* shooter_snd = "shooter_snd.wav";
SOUND* firework_1_snd = "firework_1.ogg";
SOUND* fuse_burning_snd = "fuse_burning.ogg";
SOUND* splashing_snd = "splasher_fire.ogg";
//////////////////////////////////////////Bilder//////////////////////////////////////////
BMAP* splash_tga = "splash.tga";
BMAP* funken_tga = "funken.tga";
BMAP* effect_1_tga = "effect_1.tga";
BMAP* rauch_bmp = "smoke.tga";
//////////////////////////////////////////Sound///////////////////////////////////////////

/////////////////////////////////////////Entitys//////////////////////////////////////////
ENTITY* rakete[3];
ENTITY* sprayer[2];
ENTITY* shooter;
/////////////////////////////////////////Panels///////////////////////////////////////////
PANEL* splash_screen =
{
	bmap = splash_tga;
	flags = SHOW;
}
PANEL* text_2_help =
{
	digits(0,0, "Press F1 for Help", arial_normal, 1, 0);
}
PANEL* help2_pan = 
{
	digits(400,288, "Space: Start the firework", arial_normal, 1, 0);
	digits(400,333, "Esc to End", arial_normal, 1, 0);
	flags = CENTER_X;
}
////////////////////////////////////////Functions/////////////////////////////////////////
function help()
{
	while(1)
	{
		if(key_f1)
		{
			toggle(help2_pan, SHOW);
			while(key_f1) wait(1);
		}
		wait(1);
	}
}
function camera_update()
{
	VECTOR temp;
	while(1)
	{
		vec_set(temp,rakete[0].x);
		vec_sub(temp,camera.x);
		vec_to_angle(camera.pan,temp);
		wait(1);
	}
}
function funken_away(PARTICLE *p)
{
	vec_scale(p.blue, 0.7);
	p.alpha -= 20 * time_step;
	if(p.alpha <= 0) p.lifespan = 0;
}
function smooth_away(PARTICLE *p)
{
	p.alpha -= 7 * time_step;
	if(p.alpha <= 0) p.lifespan = 0;
}
function funken_effect(PARTICLE *p)
{
	p.bmap = funken_tga;
	p.size = 1;
	p.vel_x = random(10)-5;
	p.vel_y = random(10)-5;
	p.vel_z = random(10)-5;
	p.alpha = random(25)+25;
	p.flags |= (MOVE);
	p.lifespan = 3;
	p.event = funken_away;
}
function firework_1(PARTICLE *p)
{
	p.bmap = effect_1_tga;
	p.size = 5;
	p.alpha = random(20)+50;
	p.lifespan = 30;
	p.event = funken_away;
}
function firework_2(PARTICLE *p)
{
	p.bmap = effect_1_tga;
	p.size = 5;
	p.alpha = random(50)+50;
	p.event = smooth_away;
}
function splash_away(PARTICLE *p)
{
	p.alpha -= 10 * time_step;
	if(p.alpha <= 0) p.lifespan = 0;
}
function firework_spayer(PARTICLE *p)
{
	p.bmap = funken_tga;
	p.size = 3;
	p.vel_x = random(7)-3.5;
	p.vel_y = random(7)-3.5;
	p.alpha = random(25)+25;
	p.z += random(20);
	p.flags |= (MOVE | BRIGHT);
	p.lifespan = 80;
	p.event = splash_away;
}
function rauch_away(PARTICLE *p)
{
	p.alpha -= 3 * time_step;
	p.lifespan = 80;
	if(p.alpha <= 0) p.lifespan = 0;
}
function rauch_1_effect(PARTICLE *p)
{
	p.bmap = rauch_bmp;
	p.size = 10;
	p.vel_x = random(5)-2.5;
	p.vel_y = random(5)-2.5;
	p.alpha = random(40)+25;
	p.flags |= (MOVE);
	p.event = rauch_away;
}
function rauch_2_effect(PARTICLE *p)
{
	p.bmap = rauch_bmp;
	p.x += random(2)-1;
	p.y += random(2)-1;
	p.z += random(2)-1;
	p.vel_x = random(3)-1.5;
	p.vel_y = random(3)-1.5;
	p.size = 13;
	p.alpha = random(40)+25;
	p.flags |= (MOVE);
	p.event = rauch_away;
}
function rakete_func()
{
	ENTITY* dummy;
	VECTOR temp;
	var i = 0;
	var snd;
	while(status != 2) wait(1);
	snd = ent_playloop(me, fuse_burning_snd, 200);
	dummy = ent_create(NULL, nullvector, NULL);
	vec_set(dummy.x, vec_for_vertex(temp, me, 3));
	dummy.lightrange = 30;
	dummy.red = 200;
	dummy.green = 200;
	dummy.blue = 0;
	while(i < 250)
	{
		vec_for_vertex(temp, me, 3);
		vec_set(dummy.x, vec_for_vertex(temp, me, 3));
		dummy.z += i/15;
		temp.z += i/15;
		effect(funken_effect, 10, temp, normal);
		i++;
		wait(1);
	}
	snd_stop(snd);
	dummy = ent_create("spehre_1.mdl", nullvector, NULL);
	set(dummy, INVISIBLE);
	while(my.z <= 1500)
	{
		c_move(me, vector(0,0, 75 * time_step), nullvector, 0);
		vec_set(dummy.x, my.x);
		effect(firework_spayer, 60, vec_for_vertex(temp, me, 442), normal);
		effect(rauch_1_effect, 4, temp, normal);
		effect(rauch_2_effect, 4, vec_for_vertex(temp, me, 442), normal);
		wait(1);
	}
	dummy.lightrange = 0;
	vec_set(dummy.x, my.x);
	i = 1;
	set(me, INVISIBLE);
	ent_playsound(me, firework_1_snd, 1000);
	dummy.lightrange = 300;
	while(vec_dist(vec_for_vertex(temp, dummy, 78), my.x) < 200)
	{
		while(i < ent_vertices(dummy))
		{
			effect(firework_1, 1, vec_for_vertex(temp, dummy, i), nullvector);
			i++;
		}
		dummy.scale_x += 1.3;
		dummy.scale_y += 1.3;
		dummy.scale_z += 1.3;
		i = 0;
		wait(1);
	}
	i = 0;
	while(i < ent_vertices(dummy))
	{
		effect(firework_2, 1, vec_for_vertex(temp, dummy, i), nullvector);
		i++;
	}
}
function sprayer_away(PARTICLE *p)
{
	if(p.skill_b == 1) p.size += 0.1;
	p.skill_a++;
	p.alpha -= 2 * time_step;
	p.lifespan = 80;
	if(p.skill_a > 50+random(10)) p.lifespan = 0;
}
function sprayer_effect(PARTICLE*p)
{
	p.bmap = funken_tga;
	p.size = 1;
	p.x += random(3)-1.5;
	p.y += random(3)-1.5;
	p.vel_x = random(1)-0.5;
	p.vel_y = random(1)-0.5;
	p.vel_z = random(max_high)+3;
	p.alpha = random(25)+25;
	p.flags |= (MOVE | BRIGHT);
	p.green = random(40)+50;
	if(random(10) > 9) p.skill_b = 1;
	p.lifespan = 3;
	p.event = sprayer_away;
}
function sprayer_extra(PARTICLE *p)
{
	var angle;
	angle = random(360);
	p.bmap = funken_tga;
	p.size = 1;
	p.x += random(3)-1.5;
	p.y += random(3)-1.5;
	p.vel_x = cos(angle)*3;
	p.vel_y = sin(angle)*3;
	p.vel_z = random(3)+5;
	p.alpha = random(25)+25;
	p.flags |= (MOVE | BRIGHT);
	p.gravity = 1;
	p.lifespan = 3;
	p.event = sprayer_away;
}
function sprayer_func()
{
	VECTOR temp;
	var i = 0;
	var snd;
	while(key_space == 0) wait(1);
	snd = ent_playloop(me, splashing_snd, 300);
	while(i <  400)
	{
		vec_for_vertex(temp, my, 2);
		temp.z += random(3)-1.5;
		effect(sprayer_effect, 15, temp, nullvector);
		effect(sprayer_extra, 2, temp, nullvector);
		if(i > 350) max_high -= time_step;
		i++;
		wait(1);
	}
	snd_stop(snd);
	status = 1;
}
function shooter_away(PARTICLE *p)
{
	p.skill_a++;
	p.alpha -= time_step;
	p.lifespan = 80;
	if(p.skill_a > 80) p.lifespan = 0;
}
function shooter_effect(PARTICLE *p)
{
	p.bmap = funken_tga;
	p.size = 6;
	p.vel_x = random(1)-0.5;
	p.vel_y = random(1)-0.5;
	p.vel_z = random(4)+20;
	p.alpha = random(75)+25;
	p.green = random(255);
	p.blue = random(255);
	p.red = random(255);
	p.skill_a = 0;
	p.flags |= (MOVE | BRIGHT);
	p.lifespan = 3;
	p.event = shooter_away;
}
function shooter_func()
{
	VECTOR temp;
	var i;
	var snd;
	while(status != 1) wait(1);
	while(i < 8)
	{
		vec_for_vertex(temp, me, 2);
		snd = ent_playsound(me, shooter_snd, 200);
		effect(shooter_effect, 1, temp, nullvector);
		i++;
		wait(random(30)+40);
	}
	status = 2;
}
function flasche()
{
	set(me, TRANSLUCENT);
	my.alpha = 50;
}